#!/usr/bin/perl

# opera-hotlist2html.pl
# Copyright (C) 2001 Alan Hoyle <alan@alanhoyle.com>
#
# This program is derivitive of:  
#
# hotlist2xbel.pl
# Copyright (C) 2001 Haakon Nilsen <haakon@nilsen.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#


#
# Global Changes:  
#
# 23 March 2001:  replaced "xbel" with "html"
# 26 March 2001:  added comments and re-indented code
# 28 March 2001:  changed name to "opera-hotlist2html"
#

$VERSION = "1.0";

sub get_next_line {
    if (!eof($in)) {
	$a = <$in>;
	$a =~ s/\n//; # Chop didn't work...
	$a =~ s/\t//;
	return $a;
    }
}

sub write_html {
    print(&get_indent ."$_[0]\n");
}

sub parse {
    &inc_indent;
    while (!eof($in)) {
	$line = get_next_line;
      SWITCH: {
	  if ($line eq "#FOLDER") {
	      &parse_folder;
	      last SWITCH;
	  }
	  if ($line eq "#URL") {
	      &parse_url;
	      last SWITCH;
	  }
      }
    }
    &dec_indent;
}

sub parse_folder {
    
#
# 23 March 2001: replaced xbel specific tags with html tags
#
    
    my $line, $name, $value;
    $line = get_next_line;
    while ($line ne "") {
	if ($line =~ /=/) {
	    ($name, $value) = split(/=/, $line);
	    $attrib{$name} = $value;
	}
	$line = get_next_line;
    }
    &write_html("<h3>" .$attrib{"NAME"} ."</h3>");
    
    &write_html("<ul>");
    &inc_indent;
    while ($line ne "-") {
	$line = get_next_line;
      SWITCH: {
	  if ($line eq "#FOLDER") {
	      &parse_folder;
	      last SWITCH;
	  }
	  if ($line eq "#URL") {
	      &parse_url;
	  }
      }
    }
    &dec_indent;
    &write_html("</ul><p>");
}

sub parse_url {
#
# 23 March 2001: replaced xbel specific tags with html tags
#
    my $bookmark, $line, $name, $value;
    $line = get_next_line;
    while ($line ne "") {
	if ($line =~ /=/) {
	    ($name, $value) = split(/=/, $line);
	    $bookmark{$name} = $value;
	}
	$line = get_next_line;
    }
    $bookmark{"URL"} =~ s/\&/\%26\;/;
    $bookmark{"NAME"} =~ s/\&/\&amp\;/;
    &write_html("<li><a href=\"" .$bookmark{"URL"} ."\">" .$bookmark{"NAME"} ."</a>");
}

sub inc_indent {
    $indent++;
}

sub dec_indent {
    $indent--;
}

sub get_indent {
    $ind = "";
    for ($i = 0; $i < $indent - 1; $i++) { $ind .= "   "; }
    return $ind;
}


if (($ARGV[0] eq "--help")||($ARGV[0] eq "-h")) {

#
# 23 March 2001: Changed this to new, updated information
#

    print("operahotlist2html.pl $VERSION by Alan Hoyle <alan\@alanhoyle.com>\n");
    print("   derived from hotlist2xbel.pl 1.0 by Haakon Nilsen <haakon\@nilsen.com>\n");
    print("   Reads from stdin, writes to stdout.\n");
    print("   add a \"STRING\" after the command to personalize the output.\n");
    exit;
}

$fullname = $ARGV[0];


$in = *STDIN;
$err = *STDERR;

$l = get_next_line;
if ($l ne "Opera Hotlist version 2.0") {
    print($err, "\nHotlist version not supported! Only 2.0 supported. No soup for you.\n");
   exit;
} else 
{
    $indent = 1;
    
#
# 23 March 2001: replaced xbel specific tags with html tags
#
    
    &write_html("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/REC-html401/loose.dtd\">\n<html>");
    &inc_indent;
    &write_html("<head><title>Bookmarks:  $fullname</title></head>");
    &write_html("<body>");
    &inc_indent;
    &write_html("<h1>Bookmarks:  $fullname</h1>");
    &write_html("<ul>");
    
    &parse;
    
    &write_html("</ul><p>");
    &dec_indent;
    &write_html("</body>");
    &dec_indent;
    &write_html("</html>");
}

exit;








